﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Analysis.AlgorithmBehavior.Analyzers {
  [Item("UnwantedMutationAnalyzer", "A base class for items that calculate unwanted mutations.")]
  [StorableClass]
  public abstract class UnwantedMutationAnalyzer : Item, IUnwantedMutationAnalyzer {
    [Storable]
    public string SolutionVariableName { get; set; }

    [StorableConstructor]
    protected UnwantedMutationAnalyzer(bool deserializing) : base(deserializing) { }
    protected UnwantedMutationAnalyzer(UnwantedMutationAnalyzer original, Cloner cloner)
      : base(original, cloner) {
      this.SolutionVariableName = original.SolutionVariableName;
    }

    public UnwantedMutationAnalyzer()
      : base() { }

    public abstract double AnalyzeUnwantedMutations(IScope parent1, IScope parent2, IScope child);
  }
}
